summaryrefslogtreecommitdiff
path: root/boot
diff options
context:
space:
mode:
authorIan Lynagh <igloo@earth.li>2010-04-15 14:39:19 +0000
committerIan Lynagh <igloo@earth.li>2010-04-15 14:39:19 +0000
commit6ddc8fd8b4952a23d1016dbad4263b89b63c5ae3 (patch)
tree7083c0df5618a318b97671bc019c3f933a91f91d /boot
parent113f9dafa36f19279e43377bad60bfcefd36b334 (diff)
downloadhaskell-6ddc8fd8b4952a23d1016dbad4263b89b63c5ae3.tar.gz
Convert boot and boot-pkgs to perl
This stops us having to worry about sh/sed/... portability.
Diffstat (limited to 'boot')
-rw-r--r--boot80
1 files changed, 49 insertions, 31 deletions
diff --git a/boot b/boot
index 6b04fcc0c4..70d99e692a 100644
--- a/boot
+++ b/boot
@@ -1,39 +1,57 @@
-#! /bin/sh
-set -e
+#!/usr/bin/perl -w
+
+use strict;
+
+use Cwd;
# Create libraries/*/{ghc.mk,GNUmakefile}
-bash boot-pkgs
+system("/usr/bin/perl", "-w", "boot-pkgs") == 0
+ or die "Running boot-pkgs failed: $?";
+
+my $dir;
+my $curdir;
+
+$curdir = &cwd();
# Check that we have all boot packages.
-for dir in `grep "^[^# ][^ ]* *[^ ][^ ]* *[^ ][^ ]*$" packages | sed "s/ .*//"`
-do
- # We would like to just check for an _darcs directory here, but in
- # an lndir tree we avoid making _darcs directories, so it doesn't
- # exist. We therefore require that every repo has a LICENSE file
- # instead.
- if test ! -f $dir/LICENSE
- then
- echo "Error: $dir/LICENSE doesn't exist." >&2
- echo "Maybe you haven't done './darcs-all get'?" >&2
- exit 1
- fi
-done
+open PACKAGES, "< packages";
+while (<PACKAGES>) {
+ if (/^#/) {
+ # Comment; do nothing
+ }
+ elsif (/^([a-zA-Z0-9\/.-]+) *[^ ]+ *[^ ]+$/) {
+ $dir = $1;
+
+ # We would like to just check for an _darcs directory here, but in
+ # an lndir tree we avoid making _darcs directories, so it doesn't
+ # exist. We therefore require that every repo has a LICENSE file
+ # instead.
+ if (! -f "$dir/LICENSE") {
+ print STDERR "Error: $dir/LICENSE doesn't exist.\n";
+ die "Maybe you haven't done './darcs-all get'?";
+ }
+ }
+ elsif (/^([a-zA-Z0-9\/.-]+) *[^ ]+ *[^ ]+ *[^ ]+$/) {
+ # These are lines which refer to optional repositories, so their
+ # absence isn't an error.
+ }
+ else {
+ die "Bad line in packages file: $_";
+ }
+}
+close PACKAGES;
# autoreconf everything that needs it.
-for dir in . libraries/*
-do
- if test -f $dir/configure.ac
- then
- echo "Booting $dir"
- ( cd $dir && autoreconf )
- fi
-done
+foreach $dir (".", glob("libraries/*/")) {
+ if (-f "$dir/configure.ac") {
+ print "Booting $dir\n";
+ chdir $dir;
+ system "autoreconf";
+ chdir $curdir;
+ }
+}
# Alas, darcs doesn't handle file permissions, so fix a few of them.
-for f in boot darcs-all push-all validate
-do
- if test -f $f
- then
- chmod +x $f
- fi
-done
+for my $file ("boot", "darcs-all", "push-all", "validate") {
+ chmod 0755, $file if -f $file;
+}